# Budget Contextual Bandits

Constrained Contextual Bandits for Personalized Recommendation. Adding budget constraints to a few popular MAB/CB methods.

- Context-Free Epsilon Greedy
- LinUCB [[1]](#1)
- UCB-ALP [[2]](#2)
- HATCH [[3]](#3)

## Install

`pip install budget-constrained-CB`

## Use

There is an example in Jupyter [notebook](https://github.com/HongleiXie/budgetCB/blob/master/example_data/example.ipynb).

## Reference

<a id="1">[1]</a>
Li, Lihong, et al. "A contextual-bandit approach to personalized news article recommendation." *Proceedings of the 19th international conference on World wide web.* 2010.

<a id="2">[2]</a>
Wu, Huasen, et al. "Algorithms with logarithmic or sublinear regret for constrained contextual bandits." *Advances in Neural Information Processing Systems.* 2015.

<a id="3">[3]</a>
Yang, Mengyue, et al. "Hierarchical Adaptive Contextual Bandits for Resource Constraint based Recommendation." *Proceedings of The Web Conference 2020.* 2020.